/*
 * rr - russian roulette
 *
 * Another essential program
 *
 * GPLed
 *
 * compile with : g++ `sdl-config --cflags` -lSDL -lSDL_mixer rr.cpp -o rr
 * 
 * Little Neo, 02 July 2003
 *
 * http://submoon.freeshell.org/en/rr/
 *  
 */

#include <stdio.h>
#include <iostream.h>
#include <string.h>
#include <termios.h>
#include <unistd.h>
#include <openssl/rand.h> // universal location ?
#include <time.h>
#include <SDL.h>
#include <SDL_mixer.h>

int main(int argc, char *argv[]){

	if (argc==2 && !strcmp(argv[1], "-v")){
		cout << "Russian Roulette v0.1\n";
		cout << "by Little Neo, July 2003\n";
		cout << "http://submoon.freeshell.org/en/rr/\n";
	}
	
	else if (argc==2 && !strcmp(argv[1], "-h")){
		cout << "rr is a Russian Roulette.\n";
		cout << "rr     -> launches the russian roulette\n";
		cout << "rr -d  -> verbose mode\n";
		cout << "rr -h  -> prints this help message\n";
		cout << "rr -v  -> displays the version\n";
		cout << "During execution, press Enter to shoot again, q to exit.\n";
	}

	else if (argc==1 || (argc==2 && !strcmp(argv[1], "-d"))){
		char dirname[256];
		strcpy(dirname, argv[0]);
		for (int i=strlen(dirname)-1; dirname[i]!='/'; i--)
			dirname[i]='\0';
		char ba[256]; strcpy(ba, dirname); strcat(ba, "ba.ogg");
		char hb[256]; strcpy(hb, dirname); strcat(hb, "hb.ogg");
		char file0[256]; strcpy(file0, dirname); strcat(file0, "0.ogg");
		char file1[256]; strcpy(file1, dirname); strcat(file1, "1.ogg");
		SDL_Init(SDL_INIT_AUDIO|SDL_INIT_NOPARACHUTE);
		bool display=(argc==2 && !strcmp(argv[1], "-d"));
		if (Mix_OpenAudio(44100,MIX_DEFAULT_FORMAT,2,1024)!=0) display=true;
		srand(time(NULL)) ;
		// let's consider the manhurin MR 73
		const int noh=6;
		int bullet=(int)((float)rand()/RAND_MAX*noh);
		int position=(int)((float)rand()/RAND_MAX*noh);
		bool shot=false;
		Mix_Music *sound;
		// termios code from a Usenet faq, note i could have used SDL functions
		struct termios tt;
                struct termios tt_old;
                unsigned char c;

		sound = Mix_LoadMUS(ba);
		int roll=(Mix_PlayMusic(sound, 1));
		SDL_Delay(2000);
		
		while (!shot){
		
			int vol=Mix_VolumeMusic(MIX_MAX_VOLUME);
			sound = Mix_LoadMUS(hb);
			int louder=Mix_FadeInMusic(sound, 1, 3800);
			SDL_Delay(4000);
					
			position = (position + 1) % noh;
			if (position == bullet){
				sound = Mix_LoadMUS(file1);
				if (Mix_PlayMusic(sound, 1)) display=true;
				if (display) cout << "Boom\n";
				shot=true;
				SDL_Delay(1500);
			}
			else{
				sound = Mix_LoadMUS(file0);
				if (Mix_PlayMusic(sound, 1)) display=true;
				if (display) cout << "Clic\n";
				bool enter_pressed=false;
				while (!enter_pressed){  // ok i modified the code	
					tcgetattr(STDIN_FILENO, &tt);
					tt_old = tt;
					cfmakeraw(&tt);
					tcsetattr(STDIN_FILENO, TCSAFLUSH, &tt);
					c = fgetc(stdin);
					tcsetattr(STDIN_FILENO, TCSAFLUSH, &tt_old);
					if (c == 13) enter_pressed=true;
					if (c == 'q') return 0;
				}
				SDL_Delay(500);
			}
		
		}
		Mix_CloseAudio();
		SDL_Quit();
	}
	
	else{
		cout << "Sorry, invalid arguments. Try rr -h.\n";
	}
	return 0;
}


